/*
 * CSBasicType.h
 *
 *  Created on: 14 avr. 2010
 *      Author: bboulay
 */

#ifndef CSBASICTYPE_H_
#define CSBASICTYPE_H_

#include <string>
#include <vector>
#include <iostream>
#include <map>
#include <tr1/memory>
//#include <std::tr1/make_shared.hpp>

class CSBasicType {
public:
	CSBasicType() {
		m_confidence = 1.0;
		m_current = false;
	}

	CSBasicType(const CSBasicType& i_value) {
		m_class = i_value.m_class;
		m_confidence = i_value.m_confidence;
		m_current = i_value.m_current;
		m_history = i_value.m_history;
	}

	/*void delete_history()
	{
		if (m_history)
		{
			m_history->delete_history();
			m_history.reset();
		}
	}*/

	virtual ~CSBasicType()
	{
		//std::cout << "begin call Basic destructor" << std::endl;
		/*std::map<int, std::tr1::shared_ptr<CSBasicType> >::iterator l_iter;
		for (l_iter=m_history.begin(); l_iter!=m_history.end(); ++l_iter)
		{
			//std::cout << l_iter->second.use_count() << " ";
			l_iter->second.reset();
			//std::cout << l_iter->second.use_count() << std::endl;
		}*/
		//std::cout << "end call Basic destructor" << std::endl;
		m_history.clear();
		//m_history.reset();
		//delete_history();
		//m_history.reset();

		//m_temphistory.clear();
	}

public:
	std::string m_class;
	double m_confidence;
	//Is the current value or one of the history
	bool m_current;
	int m_pos;
	std::map<int, std::tr1::shared_ptr<CSBasicType> > m_history;
	//std::tr1::shared_ptr<CSBasicType> m_history;
	//std::map<int, std::tr1::weak_ptr<CSBasicType> > m_temphistory;

};

#endif /* CSBASICTYPE_H_ */




