#ifndef SUPABSTRACTDATA_P_H
#define SUPABSTRACTDATA_P_H

#include <dtkCore/dtkAbstractData_p.h>

class supAbstractData;

////////////////////////////////////////////////////
// supAbstractDataPrivate interface
////////////////////////////////////////////////////

class DTKCORE_EXPORT supAbstractDataPrivate : public dtkAbstractDataPrivate
{
public:
    supAbstractDataPrivate(supAbstractData *q = 0) : dtkAbstractDataPrivate(q) {}
    supAbstractDataPrivate(const supAbstractDataPrivate& other) : dtkAbstractDataPrivate(other), specific_properties(other.specific_properties) {}

public:
    virtual ~supAbstractDataPrivate(void) {}

public:
    QVariantMap specific_properties;
    QVariantMap m_map;
};

////////////////////////////////////////////////////
// supAbstractData protected constructors
////////////////////////////////////////////////////

DTK_IMPLEMENT_PRIVATE(supAbstractData, dtkAbstractData);

#endif

