/*
 * qt_support.h
 *
 *  Created on: Feb 8, 2013
 *      Author: sbak
 */

#ifndef QT_SUPPORT_H_
#define QT_SUPPORT_H_

#include "common.h"

#include<iostream>
#include<fstream>
#include<sstream>

//QT Library
#include <qdom.h>
#include <qtextstream.h>
#include <qstring.h>
#include <QFile>
#include <qstringlist.h>
#include <qdatetime.h>

//LTI library
#include <ltiMatrix.h>

QString BoolVectorToString(std::vector<bool>& v);

std::vector<bool> StringToBoolVector(QString vector);

QString MatrixToString(lti::matrix<float>& matrix);

lti::matrix<float> StringToSQRTMatrix(QString matrix);

lti::matrix<float> StringToMatrix1D(QString matrix);



#endif /* QT_SUPPORT_H_ */
