#ifndef SUPCOMPOSERNODEPROCESSBLOBGENERATOR_H
#define SUPCOMPOSERNODEPROCESSBLOBGENERATOR_H

#include <dtkComposer/dtkComposerNodeLeafProcess.h>

#include "supComposerExport.h"

class supComposerNodeProcessBlobsGenerationPrivate;

// /////////////////////////////////////////////////////////////////
// supComposerNodeProcessBlobsGeneration interface
// /////////////////////////////////////////////////////////////////

class SUPCOMPOSER_EXPORT supComposerNodeProcessBlobsGeneration : public dtkComposerNodeLeafProcess
{
public:
     supComposerNodeProcessBlobsGeneration(void);
    ~supComposerNodeProcessBlobsGeneration(void);

public:
    QString type(void);
    QString titleHint(void);

public:
    QString  inputLabelHint(int port);
    QString outputLabelHint(int port);

public:
    bool isAbstractProcess(void) const;

    QString abstractProcessType(void) const;
    
public:
    void run(void);

private:
    supComposerNodeProcessBlobsGenerationPrivate *d;
};

#endif

