#ifndef SKELETON_STRUCTURE
#define SKELETON_STRUCTURE 1

#include <opencv2/core/core.hpp>

struct Position2d3d {
    cv::Point2i pos2d;
    cv::Point3f pos3d;
    Position2d3d() {
        pos2d.x = pos2d.y = -1;
        pos3d.x = pos3d.y = pos3d.z = 0;
    }
};

struct SkeletonStructure {
    Position2d3d headCenterPos;
    SkeletonStructure() : headCenterPos() {
    };
};

#endif
