 #ifndef SUPABSTRACTPROCESS_P_H
 #define SUPABSTRACTPROCESS_P_H
 
 #include <dtkCore/dtkAbstractProcess_p.h>
 
 class supAbstractProcess;
 
 ////////////////////////////////////////////////////
 // supAbstractProcessPrivate interface
 ////////////////////////////////////////////////////
 
 class DTKCORE_EXPORT supAbstractProcessPrivate : public dtkAbstractProcessPrivate
 {
 public:
     supAbstractProcessPrivate(supAbstractProcess *q = 0) : dtkAbstractProcessPrivate(q), _synchronizer() {}
     supAbstractProcessPrivate(const supAbstractProcessPrivate& other) : dtkAbstractProcessPrivate(other), _synchronizer(other._synchronizer), specific_parameters(other.specific_parameters) {}
 
 public:
     virtual ~supAbstractProcessPrivate(void) {}
 
 public:
    CSynchronizer _synchronizer;
    QVariantMap specific_parameters;
 };
 
 ////////////////////////////////////////////////////
 // supAbstractProcess protected constructors
 ////////////////////////////////////////////////////
 
 DTK_IMPLEMENT_PRIVATE(supAbstractProcess, dtkAbstractProcess);
 
 #endif
